#include <sys/socket.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <unistd.h>
#include <errno.h>

// solaris
#include <sys/types.h>
#include <sys/socket.h>
// solaris

#include "DPF_client.h"
#include "DPF.h"

extern int _DPF_initialized;
extern DPF_fdInfo _DPF_fd[];
extern int _DPF_maxfd;

extern "C" {
pid_t
DPF_fork(void)
{
    if (!_DPF_initialized) {
        DPF_init(NULL, NULL, 0);
    }

    for(int i=0; i<_DPF_maxfd; i++) {
        if (_DPF_fd[i].type == TCP_UNCLASSIFIED || _DPF_fd[i].type == TCP_CLIENT ||
                _DPF_fd[i].type == TCP_SERVER || _DPF_fd[i].type == UDP) {
            ClientSock *sock = (ClientSock *) _DPF_fd[i].info;
            sock->forked = true;
        }
    }

    pid_t pid = fork();
    return pid;
}
} // extern "C"
