#ifndef __SVR_COMMON
#define __SVR_COMMON

#include "DPF_common.h"
typedef enum _DPF_server_status {
    // Client state
    ACCEPTING,
    CONNECTED,
    SERVING_1, SERVING_2, SERVING_3,
    SERV_FAILED,
    // Connector state
    CONNECT_DEST_AGENT_1,
    CONTACT_DEST_AGENT_1,
    CONTACT_DEST_AGENT_2,
    CONNECTION_FAILED,
    INTRA_CONNECTING,
    TCP_ACTIVE_CONNECTING,
    UDP_ACTIVE_CONNECTING,
    TCP_PASSIVE_CONNECTING_1,
    TCP_PASSIVE_CONNECTING_2,
    TCP_PASSIVE_CONNECTING_3,
    UDP_PASSIVE_CONNECTING_1,
    UDP_PASSIVE_CONNECTING_2,
    UDP_PASSIVE_CONNECTING_3,
    UDP_PASSIVE_CONNECTING_4,
    TCP_ARRANGING_RELAY_01,
    TCP_ARRANGING_RELAY_02,
    UDP_ARRANGING_RELAY_01,
    UDP_ARRANGING_RELAY_02,
    ARRANGING_RELAY,
    FINISHING,
    FINISHED,
    // Listener state
    CONNECT_INAGENT_1,
    REGISTERING_1,
    REGISTERING_2,
    BIND_FAIL,
    LISTEN_FAIL,
    FULL_BOUND,
    LISTENING_2,
    FULL_LISTEN,
    // Relay state
    ACCEPTING_CONNECTOR_1,
    ACCEPTING_CONNECTOR_2,
    CONNECTED_2_CONNECTOR,
    CONNECTING_LISTENER,
    ACCEPTING_LISTENER_1,
    ACCEPTING_LISTENER_2,
    CONNECTED_2_LISTENER,
    TCP_RELAYING,
    UDP_RELAYING,
    RELAY_FAILED
} DPF_server_status;

#define TCP 't'
#define UDP 'u'
#define UNKNOWN 'n'

struct fd_desc {
    DPF_fd_type type;
    void *info;
};

#endif
