#include <string.h>
#include <time.h>
#include "inagent.h"

extern char *_server_status_str[];

Connector::Connector(int fd)
{
    conn = new DPF_channel(fd);
    status = CONTACT_DEST_AGENT_1;
    entered = time(NULL);
    listener = NULL;
    error = 0;
}

Connector::~Connector()
{
    delete conn;
}

void
Connector::tostr(const char *prefix, char *str)
{
    struct in_addr inaddr;
    sprintf(str, "status=%s ", _server_status_str[status]); 
    sprintf(&str[strlen(str)], "entered=%lu\n", entered); 
    sprintf(&str[strlen(str)], "%sconn=", prefix);
    if (conn) {
        conn->tostr("", &str[strlen(str)]);
    } else {
        strcat(str, "NULL");
    }
    sprintf(&str[strlen(str)], "\n%s", prefix);
    if (listener) {
        sprintf(&str[strlen(str)], "listener=%d", listener->conn->get_fd());
    }
}
