#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#include "internet.h"
#include "DPF.h"

int
main(int argc, char *argv[])
{
    int fd = atoi(argv[1]);
    printf("udp_echo_server: sock(%d)\n", fd);

    int bytes;
    int total, sent;
    char buf[10000];

    while(true) {
        struct sockaddr_in from;
        socklen_t fromlen = sizeof(struct sockaddr_in);
        char buf[1000];
        int bytes = DPF_recvfrom(fd, buf, 1000, 0,
                (struct sockaddr *)&from, &fromlen);
        if (bytes < 0) {
            printf("DPF_recvfrom failed: %s\n", strerror(errno));
            return -1;
        }
        printf("\t%d bytes received from: %s\n", bytes, _sin2str(&from));
        int sent = DPF_sendto(fd, buf, bytes, 0,
                (struct sockaddr *)&from, fromlen);
        if (sent < 0) {
            printf("DPF_sendto failed: %s\n", strerror(errno));
            return -1;
        }
    }
    return 0;
}
